import { defineStore } from 'pinia'

export const useZoneEditorStore = defineStore('zoneEditor', {
  state: () => ({
    active: false,
    name: '',
    width: 10,
    height: 10,
    tiles: [] as number[][],
    tool: 'move',
    drawMode: 'tile',
    selectedTile: null,
    selectedWall: null,
    selectedDecoration: null,
    isSettingsModalShown: false
  }),
  actions: {
    toggleActive() {
      this.active = !this.active
    },
    setName(name: string) {
      this.name = name
    },
    setWidth(width: number) {
      this.width = width
    },
    setHeight(height: number) {
      this.height = height
    },
    setTiles(tiles: number[][]) {
      this.tiles = tiles
    },
    setTool(tool: string) {
      this.tool = tool
    },
    setDrawMode(mode: string) {
      this.drawMode = mode
    },
    setSelectedTile(tile: any) {
      this.selectedTile = tile
    },
    setSelectedWall(wall: any) {
      this.selectedWall = wall
    },
    setSelectedDecoration(decoration: any) {
      this.selectedDecoration = decoration
    },
    toggleSettingsModal() {
      this.isSettingsModalShown = !this.isSettingsModalShown
    },
    reset() {
      this.name = ''
      this.width = 10
      this.height = 10
      this.tiles = []
      this.tool = 'move'
      this.drawMode = 'tile'
      this.selectedTile = null
      this.selectedWall = null
      this.selectedDecoration = null
      this.isSettingsModalShown = false
    }
  }
})